
# coding: utf-8

# In[130]:

get_ipython().magic(u'matplotlib inline')

import csv
import requests
import ggplot
import matplotlib
matplotlib.use('agg')
matplotlib.style.use('ggplot')
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import statsmodels as sm
from sklearn import linear_model
from sklearn.gaussian_process import regression_models
from StringIO import StringIO

# need ssh tunnel to use this url
url = 'http://localhost:2200/erp5/portal_skins/erp5_r_order_prediction_tutorial/SaleOrderModule_getArimaPredictionList'
response = requests.get(url, auth=('zope', 'password'))
csv_file = StringIO()
csv_file.write(response.text)
csv_file.seek(0)

ts = pd.read_csv(csv_file, sep=';',
                 parse_dates=[0],
                 infer_datetime_format=True,
                 squeeze=True,
                 index_col='date')

X = (ts.index - ts.index[0]).days.reshape(-1, 1)
y = ts.values

X_train = X[:]
X_test = X[20:]

y_train = y[:]
y_test = y[20:]

# Linear Regression
lr = linear_model.LinearRegression(normalize=True)
lr.fit(X_train, y_train)
print lr.score(X_test, y_test)

plt.scatter(X_test, y_test, color='black')
plt.plot(X_test, lr.predict(X_test), color='blue', linewidth=3)

# ElasticNet Regression

mtl = linear_model.ElasticNet(alpha=0.1, normalize=True)
mtl.fit(X_train, y_train)
plt.plot(X_test, mtl.predict(X_test), color='green', linewidth=2)

# SGD Regression

sgd = linear_model.SGDRegressor(shuffle=False, eta0=0.25)
sgd.fit(X_train, y_train)
plt.plot(X_test, sgd.predict(X_test), color='red', linewidth=1)

plt.xticks()
plt.yticks()
plt.show()